#include <avr/io.h>

int main(void)
{
    int i=0;

    //Die 16 im Voraus berechneten  und im Bereich 0..255 skalierten Sinuswerte:
    unsigned char sinus[16] = {128,176,218,245,255,245,218,176,
                               128,79,37,10,0,10,37,79};

    DDRD |= 0b10000000;

    //Konfigurieren des Timers 2 als PWM-Ausgang im Fast-PWM-Mode, OC2 set on compare match,
    //Vorteilung 1:
    TCCR2 = (0<<FOC2) | (1<<WGM20) | (1<<COM21) | (0<<COM20)
          | (1<<WGM21) | (0<<CS22) | (0<<CS21) | (1<<CS20);


    //Konfigurieren des Timers 1 als normaler Zhler,
    //Vorteilung 8:
    TCCR1A = (0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0)
           | (0<<FOC1A) | (0<<FOC1B) | (0<<WGM11) | (0<<WGM10);
    TCCR1B = (0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12)
           | (0<<CS12) | (1<<CS11) | (0<<CS10);


    while(true)
	{
        OCR2 = sinus[i];
        while(TCNT1<164);
        TCNT1 = 0; 
        i++;
        i%=16;
	}
	return 0;
}
